<?php

namespace FiloBlu\Flow\Model\Actions\From;

class Name {

    CONST ENTITY_TYPE_CODE = 'catalog_product';
    protected $_helper_product;
    
    public function __construct(
        \Magento\Framework\Model\Context $context,
        \Magento\Framework\Registry $registry,
        \FiloBlu\Flow\Helper\Product $helper_product,
        \Magento\Framework\Model\ResourceModel\AbstractResource $resource = null,
        \Magento\Framework\Data\Collection\AbstractDb $resourceCollection = null,
        array $data = []
    ) {
        $this->_helper_product = $helper_product;
    }

    public function process($product, $value, $storeId) {
        
        if(empty($value)){
            return true;
        }

       $parent_product_id = \Magento\Framework\App\ObjectManager::getInstance()->create('Magento\ConfigurableProduct\Model\ResourceModel\Product\Type\Configurable')->getParentIdsByChild($product->getId());
       if(isset($parent_product_id[0])){
                
                $fatherProduct = \Magento\Framework\App\ObjectManager::getInstance()->create('Magento\Catalog\Model\Product')->load($parent_product_id[0]);
                if($fatherProduct->getUrlKey() != $fatherProduct->formatUrlKey($value)){
                    self::setProductName($fatherProduct, $value, $storeId);
              
            }
        }

        self::setProductName($product, $value, $storeId);
        return true;
    }

    protected static function setProductName($product, $name, $storeId){
        
        $urlKey = $product->formatUrlKey($name);

        $pids = array($product->getId());
        $attributesData = array('name' => $name, 'url_key' => $urlKey);

        try{
            \Magento\Framework\App\ObjectManager::getInstance()->get('Magento\Catalog\Model\Product\Action')
                ->updateAttributes($pids, $attributesData, $storeId);

        } catch (\Exception $e){
            $message = "Problem while processing eavs, <br/> store id : ".$storeId."<br/> pids : ".print_r($pids,true). "<br/> attribute data : ".print_r($attributesData,true);
            $message .= "<br/> \Exception : ".$e->getMessage();
            $message .= "<br/> Backtrace : <br/> ".nl2br($e->getTraceAsString());
            FiloBlu_Flow_Model_From_Eavs::sendErrorEmail($message);
            throw new \Exception($e->getMessage());
        }

    }

}
